/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;



public class PrivateMessageSerializer implements JsonSerializer<PRIVATEMESSAGE> {

  @Override
  public JsonElement serialize(PRIVATEMESSAGE privatemessage, Type type, JsonSerializationContext context) {

    JsonObject jsonObject = new JsonObject();

    JsonObject dataset = new JsonObject();
    dataset.add(PRIVATEMESSAGE.PSEUDOID, context.serialize(privatemessage.getPseudoid()));
    dataset.add(PRIVATEMESSAGE.REMOTE_PSEUDOID, context.serialize(privatemessage.getRemotePseudoid()));
    dataset.add(PRIVATEMESSAGE.MESSAGE, context.serialize(privatemessage.getMessage()));
    dataset.add(PRIVATEMESSAGE.DATETIME, context.serialize(privatemessage.getDatetime()));
    dataset.add(PRIVATEMESSAGE.CHATUSER, context.serialize(privatemessage.getChatUser()));
    dataset.add(Attachment.ATTACHMENT, context.serialize(privatemessage.getAttachment()));
    dataset.add(Attachment.FILENAME, context.serialize(privatemessage.getFilename()));
    dataset.add(Attachment.FILESIZE, context.serialize(privatemessage.getFilesize()));

    jsonObject.add(Protocol.HEADER, context.serialize(privatemessage.getHeader()));
    jsonObject.add("COMMAND", context.serialize(privatemessage.getCommand()));
    jsonObject.add(Protocol.DATASET, context.serialize(dataset));

    return jsonObject;

  }

}
